
/* Photoshop plug-in example */
/*
	Copyright (c) 1996-2007, J. Christian Russ and John C. Russ
	All rights reserved.

	This code may be used by purchasers of the book for educational and personal research
	purposes but not for any commercial purpose.  The Copyright notices must be preserved
	in all copies. Plug-ins utilizing or derived from this code may not be sold or 
	distributed for a fee.
*/
/* Problem 0.5.1 Reverse (Complement) Colors*/

#include "PhotoshopShell.h"


///////////////////////////////////
//
//	Main entry for user code
//
///////////////////////////////////
ErrType	MainUserEntry()	
{
	ErrType  result = noErr;								//accumulate any errors that happen
	long	  height, width;								//pixel dimensions of image
	long	  x, y;											//loop counters to traverse image
	RGBPixel *line = NULL;									//memory buffer

	GetOriginalDimensions(&width, &height);					//find out how big the image is

	line = CreateAPointer(width, sizeof(RGBPixel));			//Allocate memory for one row

	//Image "inversion" example
	for (y = 0; y < height; y++)
	{
		if (TestAbortSetProgressBar((float)y/(float)height))//progress bar position is a fraction 0.0 .. 1.0
		{	//See if user canceled
			result = userCanceledErr;
			goto mainexit;
		}

		ReadOriginalLine(y, line);							//read a line
		for (x = 0; x < width; x++)
		{	//simple black/white reversal
			line[x].red =   (float)255.0 - line[x].red;
			line[x].green = (float)255.0 - line[x].green;
			line[x].blue =  (float)255.0 - line[x].blue;
		}//for x
		WriteResultLine(y, line);							//write changed line back
	}//for y

mainexit:													//clean up everything we allocated
	if (line)
		DisposeAPointer(line);

	return result;											//pass any errors back
}//MainUserEntry

