/*
	File: PiPL.r
	
	portions Copyright (c) 1990-1, Thomas Knoll.
	portions Copyright (c) 1992-6, Adobe Systems Incorporated.
	portions Copyright (c) 1996-2007, J. Christian Russ and John C. Russ
	All rights reserved

	This file incorporates some portions of versions 3.0.4, 4.0, 
	a few lines of 5.0, and the plug-in modes of 9.0 from Photoshop's Filter 
	module interface. It also incorporates the API described in Russ&Russ, 2007

	This code may be used by purchasers of the book for educational and personal research
	purposes but not for any commercial purpose.  The Copyright notices must be preserved
	in all copies. Plug-ins utilizing or derived from this code may not be sold or
	distributed for a fee.
*/

/*********************************************************************/
// Defines required from include file */

#include "PiPLData.h"	//details for THIS plug-in

// This include file defines the following:

//	pluginMenuNamePStr32 - this is a Pascal string in a 32 byte field

//	pluginCategoryPStr32 - this is also a Pascal string in a 32 byte field

//  swappedEventID		 - this is a 4-byte string, in reversed order, 
//						   holding the unique signature for this plug-in

/*********************************************************************/

16000 PIPL DISCARDABLE
BEGIN
	0x0001, 0L, 10L, //10 fields in this PiPL
	//0x0001, 0L, 9L, //9 fields in this PiPL
	"MIB8", "dnik", 0L,	4L,	"MFB8",					//Kind { Filter }
	"MIB8",	"eman", 0L, 32L, pluginMenuNamePStr32,	//Name { plugInMenuNamePStr20 }
	"MIB8", "gtac", 0L, 32L, pluginCategoryPStr32,	//Category { plugInCategoryPStr32 }
	"MIB8", "srev", 0L, 4L, 0, 4,					//Version { minor = 0, major = 4 }
	"MIB8", "68xw", 0L, 12L, "ENTRYPOINT\x00\x00",	//Code_x86 { "ENTRYPOINT" }
	"MIB8", "mtsh", 0L, 48L, 0L, 
			"RRBk", 
			swappedEventID, 16000, "Russ", eventID,
			"\x00Russ and Russ, 2007 CRC\x00\x00",	//HasTerminology {}
	"MIB8", "edom", 0L, 4L, 0x00007850L, 			//Mode {Grayscale+RGB+Gray16+RGB48+Lab+Lab16}
//	"MIB8", "lbne", 0L, 72L,						//Enable {GrayscaleMode, RGBMode, Gray16Mode, RGB48Mode}
//			"in (PSHOP_ImageMode, GrayscaleMode, RGBMode, Gray16Mode, RGB48Mode)\x00"
	"MIB8", "lbne", 0L, 110L,						//Enable {GrayscaleMode, RGBMode, Gray16Mode, RGB48Mode}
			"in (PSHOP_ImageMode, GrayScaleMode, RGBMode, LabMode, Gray16Mode, RGB48Mode, Lab48Mode, RGB96Mode, Gray32Mode)\x00\x00"
	"MIB8", "icif", 0L, 28L, 0x0101, 0x0001,			//Flat data, no selection
							 0x0101, 0x0001,			//Flat data with selection
							 0x0101, 0x0001,			//Floating selection
							 0x0101, 0x0001,			//editable transparency, no selection
							 0x0101, 0x0001,			//editable transparency, with selection
							 0x0101, 0x0001,			//Preserved transparency, no selection
							 0x0101, 0x0001,			//Preserved transparency, with selection
													//FilterCaseInfo
	"MIB8", "gorp", 0L, 32L, pluginMenuNamePStr32,	//ProgressBar Text, 10th field
	0x0000											//PiPL terminator
END

//Notes:
//	The MenuName and Category are how the plug-in shows up under the Filter menu in Photoshop.
//	HasTerminology is not used in this plug-in because we have 1) No AETE resource, and 2) aren't 
//	demonstrating the object model for passing in parameters.
//  Mode is not capable of selecting the newer photoshop modes: Gray16 and RGB48 so we need
//	to use an Enable field to do that.
//	Finally, the ProgressBar field is used as the text that appears in the progressbar window
//	In this example, we're just setting it to the name of the plug-in.

