
/* Photoshop plug-in example */
/*
	Copyright (c) 1996-2007, J. Christian Russ and John C. Russ
	All rights reserved.

	This code may be used by purchasers of the book for educational and personal research
	purposes but not for any commercial purpose.  The Copyright notices must be preserved
	in all copies. Plug-ins utilizing or derived from this code may not be sold or 
	distributed for a fee.
*/
/* Problem 1.5.4.1a Save Reference Image */

#include "PhotoshopShell.h"


///////////////////////////////////
//
//	Main entry for user code
//
///////////////////////////////////
ErrType	MainUserEntry()	
{
	ErrType result = noErr;									//accumulate any errors that happened
	long	height, width;									//pixel dimensions of image
	long	y;												//loop counter to traverse image
	RGBPixel *line = NULL;									//memory buffer for one line of pixels

	GetOriginalDimensions(&width, &height);					//find out how big the image is

	line = CreateAPointer(width, sizeof(RGBPixel));			//allocate memory for one row from image

	InitializeRefImage(width, height);						//initialize file and write dimensions

	for (y = 0; y < height; y++)
	{	// check for abort, advance progress bar
		if (TestAbortSetProgressBar((float)y/(float)height))
		{	result = userCanceledErr;
			goto mainexit;
		}

		ReadOriginalLine(y, line);							//read a line
		WriteRefImageLine(y, line);							//copy into reference image
	}//for y

mainexit:													//clean up everything we allocated
	if (line)
		DisposeAPointer(line);

	return result;											//pass any errors back
}//MainUserEntry

